<template>
  <span
    :class="[
      [noBidsStyle,
      losingStyle,
      loseNochosenStyle,
      winStyle]
    ]"
    >{{ price }}</span>
</template>
<script>
import { formatNumber } from 'common-components/src/helpers/common'

export default {
  name: 'currentPrice',
  props: {
    item: {
      type: Object,
      default: () => {},
    }
  },
  computed: {
    price() {
      return this.item.auctionCurrentInfo.currentPrice
        ? formatNumber(this.item.auctionCurrentInfo.currentPrice / 100) + ' ₽'
        : this.isBlind && !this.item.auctionCurrentInfo.currentPrice && this.isSpotListActual
          ? '? ₽'
          : '— ₽'
    },

    // типы аукциона: item.type

    // BLIND - закрытые аукционы
    // FIRST_APPROVE - аукционы первого согласия
    // DOWNGRADE - на понижение
    isDownGrade() {
      return this.item.type === 'DOWNGRADE'
    },
    isBlind() {
      return this.item.type === 'BLIND'
    },
    isFirstApprove() {
      return this.item.type === 'FIRST_APPROVE'
    },

    isCancelled() {
      return this.item.spotOrder.orderStatus === 'CANCELLED'
    },

    // текущее состояние: item.auctionCurrentInfo.currentState

    // NO_BIDS - нет ставки
    isNoBids() {
      return this.item.auctionCurrentInfo.currentState === 'NO_BIDS'
    },
    noBidsStyle() {
      return this.isNoBids ? '-gray-slate' : ''
    },
    // LOSING - ставку перебили
    isLosing() {
      return this.item.auctionCurrentInfo.currentState === 'LOSING'
    },
    loseNochosen() {
      return this.item.auctionCurrentInfo.currentState === 'LOSING' && !this.isSpotListActual && !this.isChosenByCarrier
    },
    losingStyle() {
      return this.isDownGrade && this.isLosing && this.isSpotListActual ? '-light-raspberry-red' : ''
    },
    loseNochosenStyle() {
      return this.isDownGrade && this.loseNochosen ? 'lose_nochosen' : ''
    },
    // WIN - ставка лучшая
    isWin() {
      return this.item.auctionCurrentInfo.currentState === 'WIN' && this.isChosenByCarrier ||
          this.item.auctionCurrentInfo.currentState !== 'WIN' && this.isChosenByCarrier ||
          this.item.auctionCurrentInfo.currentState === 'WIN' && this.isSpotListActual
    },
    winStyle() {
      return this.isWin ? '-caribbean-green' : ''
    },
    // если клиент назначил победителем
    isChosenByCarrier() {
      return this.item.spotOrder.isCarrierChosen
    },
    // статус лота: item.auctionCurrentInfo.lotStatus

    // COMPLETED - завершен
    isCompleted() {
      return this.item.auctionCurrentInfo.lotStatus === 'COMPLETED'
    },
    // ACTIVE - активен
    isActive() {
      return this.item.auctionCurrentInfo.lotStatus === 'ACTIVE'
    },
    isSpotListActual() {
      return this.$route.path === '/spot-list'
    }
  },
}
</script>

<style lang="scss" scoped>
.lose_nochosen {
  text-decoration: line-through;
  color: $style-black;
}
</style>
